<?php

/////////////////////////////////////////////////////////////////////////////
// THIS UNAVAILABILITY SCRIPT TEMPLATE CAN BE USED AS A BASE FOR YOUR SCRIPT
// YOU ONLY NEED TO MODIFY THE get_availability FUNCTION
// THIS WILL ENSURE ALSO PREFETCHING MULTIPLE AVAILABILITIES IN A SINGLE CALL 
// WILL WORK WELL WITH NO ADDITIONAL CODING
/////////////////////////////////////////////////////////////////////////////

function get_availability() {
  // parameters, always use the get_param function to get them
  $start = get_param('start'); // start date (and time) as timestamp
  $end = get_param('end'); // end date (and time) as timestamp
  $duration = floor(($end - $start + 60) / 60); // duration in minutes
  $quantity = get_param('count'); // quantity
  $resource = get_param('resource'); // ID of the resource
  // you can fetch other params here, see http://www.planyo.com/faq.php?q=137 for the reference

  $can_reserve = true; // set to true if reservation is allowed, or to false otherwise
  $info_text = ""; // here you can add additional info displayed to the customer (or an error message if reservation is not possible)

  // return the pricing information as array, see http://www.planyo.com/faq.php?q=137 for full reference
  $info = array(
                "can_reserve" => $can_reserve,
                "info_text" => $can_reserve ? $info_text : null,
                "error_text" => $can_reserve ? null : $info_text,
                );
  return $info;
}

/////////////////////////////////////////////////////////////////////////////

// all date/time functions will work fine with timezone set to UTC
date_default_timezone_set ('UTC');
global $INTERNAL_PARAMS;
$INTERNAL_PARAMS = array();

function get_param ($name) {
  global $INTERNAL_PARAMS;
  if (array_key_exists ($name, $INTERNAL_PARAMS))
    return $INTERNAL_PARAMS [$name];
  if (array_key_exists ($name, $_REQUEST))
    return $_REQUEST [$name];
  return null;
}

function set_param ($name, $value) {
  global $INTERNAL_PARAMS;
  $INTERNAL_PARAMS[$name] = $value;
}

$av = get_availability();

// try to prefetch availabilities for other parameter sets (makes search much faster)
$prefetch_index = 2;
while (true) {
  if (get_param('price'.$prefetch_index.'-start')) {
    // use a different parameter set
    $params = array('start', 'end', 'resource', 'count', 'resname');
    foreach($params as $p) {
      set_param($p, get_param('price'.$prefetch_index.'-'.$p));
    }
    $additional_av = get_availability();
    $av['price'.$prefetch_index] = $additional_av;
  }
  else {
    break;
  }
  $prefetch_index++;
}

echo json_encode($av);

?>